package aspectEditor.aspectEditorUtils;
import java.util.jar.JarFile;
import java.util.*;
import java.io.*;
import edu.neu.ccs.demeter.aplib.*;
import edu.neu.ccs.demeter.*;
class SelectorL extends AspectLanguage {
  protected TraversalName traversalname;
  public TraversalName get_traversalname() { return traversalname; }
  public void set_traversalname(TraversalName new_traversalname) { traversalname = new_traversalname; }
  protected StrategyDef_List strategydef_list;
  public StrategyDef_List get_strategydef_list() { return strategydef_list; }
  public void set_strategydef_list(StrategyDef_List new_strategydef_list) { strategydef_list = new_strategydef_list; }
  protected NodeSubsetDef_List nodesubsetdef_list;
  public NodeSubsetDef_List get_nodesubsetdef_list() { return nodesubsetdef_list; }
  public void set_nodesubsetdef_list(NodeSubsetDef_List new_nodesubsetdef_list) { nodesubsetdef_list = new_nodesubsetdef_list; }
  protected SelectorName selectorname;
  public SelectorName get_selectorname() { return selectorname; }
  public void set_selectorname(SelectorName new_selectorname) { selectorname = new_selectorname; }
  protected ClassDictionaryName classdictionaryname;
  public ClassDictionaryName get_classdictionaryname() { return classdictionaryname; }
  public void set_classdictionaryname(ClassDictionaryName new_classdictionaryname) { classdictionaryname = new_classdictionaryname; }
  public SelectorL() { super(); }
  public SelectorL(TraversalName traversalname, StrategyDef_List strategydef_list, NodeSubsetDef_List nodesubsetdef_list, SelectorName selectorname, ClassDictionaryName classdictionaryname) {
    super();
    set_traversalname(traversalname);
    set_strategydef_list(strategydef_list);
    set_nodesubsetdef_list(nodesubsetdef_list);
    set_selectorname(selectorname);
    set_classdictionaryname(classdictionaryname);
  }
  public static SelectorL parse(java.io.Reader in) throws ParseException { return new Parser(in)._SelectorL(); }
  public static SelectorL parse(java.io.InputStream in) throws ParseException { return new Parser(in)._SelectorL(); }
  public static SelectorL parse(String s) {
    try { return parse(new java.io.StringReader(s)); }
    catch (ParseException e) {
      throw new RuntimeException(e.toString());
    }
  }
  void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before(this);
  }

  void universal_trv0_aft(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).after(this);
    super.universal_trv0_aft(_v_);
  }

  void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before_traversalname(this, traversalname);
    traversalname.universal_trv0(_v_);
    ((UniversalVisitor) _v_).after_traversalname(this, traversalname);
    ((UniversalVisitor) _v_).before_strategydef_list(this, strategydef_list);
    strategydef_list.universal_trv0(_v_);
    ((UniversalVisitor) _v_).after_strategydef_list(this, strategydef_list);
    ((UniversalVisitor) _v_).before_nodesubsetdef_list(this, nodesubsetdef_list);
    nodesubsetdef_list.universal_trv0(_v_);
    ((UniversalVisitor) _v_).after_nodesubsetdef_list(this, nodesubsetdef_list);
    if (selectorname != null) {
      ((UniversalVisitor) _v_).before_selectorname(this, selectorname);
      selectorname.universal_trv0(_v_);
      ((UniversalVisitor) _v_).after_selectorname(this, selectorname);
    }
    if (classdictionaryname != null) {
      ((UniversalVisitor) _v_).before_classdictionaryname(this, classdictionaryname);
      classdictionaryname.universal_trv0(_v_);
      ((UniversalVisitor) _v_).after_classdictionaryname(this, classdictionaryname);
    }
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

}
